import java.applet.*;
import java.awt.*;
import java.util.Random;

public class esempioApplet2 extends java.applet.Applet implements Runnable {
  private Dimension size;
  private Thread updateThread;
  private int updateInterval=300;
  private Random generatore = new Random(100);
  private Graphics tmpG;
  private Image tmpImg;
  private java.awt.Color bgColor=java.awt.Color.black;
  private int x=0;
  private int y=0;
  private int num_stelle=10;
  private String url="";
  private int starx[];
  private int stary[];
  private int hits=0;

  public void run() {
	while ( !Thread.interrupted() ) {
		try {
			repaint();
			Thread.sleep( updateInterval );
		} catch (InterruptedException e ) {return;}
	}
  }

  public java.awt.Color getColor(String c) {
	c = c.toLowerCase();
	if (c.compareTo("white")==0) return Color.white;
	if (c.compareTo("blue")==0 ) return Color.blue;
	if (c.compareTo("gray")==0 ) return Color.gray;
	return Color.black;
  }

  public void init(){
	String tmp = getParameter("stars");
	if (tmp!=null) num_stelle = Integer.parseInt(tmp);
	starx = new int[num_stelle];
	stary = new int[num_stelle];
	tmp = getParameter("bgcolor");
	if (tmp!=null) bgColor = getColor(tmp);
	setBackground(bgColor);
	tmp = getParameter("refresh");
	if (tmp!=null) updateInterval = Integer.parseInt(tmp);
	tmp = getParameter("url");
	if (tmp!=null) url = tmp;
	size = getSize();
	x = size.width / 2;
	y = size.height / 2;
	tmpImg = createImage(size.width, size.height);
	tmpG = tmpImg.getGraphics();
  }

  public void start() {
	if ( (updateThread == null) || (!updateThread.isAlive()))
		updateThread = new Thread(this);
	updateThread.start();
  }

  public void stop() {
	updateThread.interrupt();
  }

  public void update(Graphics g) {
	disegnaUfo(false);
	disegnaStelle(false);
	generaStelle();
	x = Math.abs((x+generatore.nextInt()%3+1)%size.width);
	y = Math.abs((y+generatore.nextInt()%3+1)%size.height);
	disegnaStelle(true);
	disegnaUfo(true);
	paint(g);
  }

  public void paint(Graphics g) {
	g.drawImage(tmpImg, 0, 0, this);
   } 

  public void destroy() {
	updateThread = null;
  }

  public void disegnaStelle(boolean flag) {
	if (flag) tmpG.setColor(Color.yellow);
		else tmpG.setColor(bgColor);
	for(int i=0; i<num_stelle; i++) {
	tmpG.drawLine(starx[i]-1, stary[i], starx[i]+1, stary[i]) ;
	tmpG.drawLine(starx[i], stary[i]-1, starx[i], stary[i]+1) ;
	}
  }

  public void disegnaUfo(boolean flag) {
	if (flag) tmpG.setColor(Color.white);
		else tmpG.setColor(bgColor);
	tmpG.drawLine(x+10, y+12, x+10, y+22);
	tmpG.drawLine(x+5, y+12, x, y+22);
	tmpG.drawLine(x+15, y+12, x+20, y+22);
	tmpG.fillOval(x, y, 15, 8);
	tmpG.drawOval(x, y, 20, 12);
  }

  public void generaStelle() {
	for(int i=0; i<num_stelle; i++) {
		starx[i] = Math.abs(generatore.nextInt())%size.width;
		stary[i] = Math.abs(generatore.nextInt())%size.height;
	}
  }


  public boolean colpito( int a, int b, int x, int y) {
	if (((a+5-x)*(a+5-x)+(b+5-y)*(b+5-y))<100) return true;
	return false;
  }

  public boolean mouseDown(Event evt, int xx, int yy) {
	if (colpito(x,y, xx, yy)) {
		hits++;
		showStatus("Colpito "+hits+" volte!");
	} else {
		showStatus("Mancato...");
	}
	if (hits>=10)
	try{	
	  java.net.URL myUrl = new java.net.URL(url);
	  getAppletContext().showDocument(myUrl, "_top");
	  stop();
	} catch(Exception e){ System.out.println("Errore:"+e.toString()); }
	return(true);
  }
}
